//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
   
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     BlueViolet
#property indicator_color4     PaleVioletRed
#property indicator_color5     DeepSkyBlue
#property indicator_width1     2
#property indicator_width4     1
#property indicator_width5     1
#property indicator_style2     STYLE_DASH
#property indicator_style3     STYLE_DOT
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Per              = 35;
extern double T3Hot            = 1.0;
extern bool   T3Original       = false;
extern int    ImpulseMaPeriod  = 7;   
extern int    ImpulseMaMode    = MODE_LWMA;  
extern int    HighLowPeriod    = 34;
extern bool   ShowChannel      = true;
extern bool   ShowZigZag       = true;
extern bool   Interpolate      = true;

extern double levelOb          = 0.80;
extern double levelOs          = 0.20;

extern string _                = "alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double buf[];
double impma[];
double HB[];
double LB[];
double ZZ[];
double ZZLow[];
double ZZHigh[]; 
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
  
int init() 
{
    IndicatorBuffers(8);
      SetIndexBuffer(0,buf);
      SetIndexBuffer(1,impma);
      SetIndexBuffer(2,ZZ);
      SetIndexBuffer(3,HB);
      SetIndexBuffer(4,LB);
      SetIndexBuffer(5,ZZLow);
      SetIndexBuffer(6,ZZHigh);
      SetIndexBuffer(7,trend);
     
      SetIndexStyle(2,DRAW_SECTION);
      SetIndexEmptyValue(0,0);
      SetIndexEmptyValue(1,0);
      SetIndexEmptyValue(2,0);
      SetIndexEmptyValue(5,0);
      SetIndexEmptyValue(6,0);
      SetIndexLabel(2,NULL);
          
      if (ShowChannel)
      {
      SetIndexStyle(3,DRAW_LINE);
      SetIndexStyle(4,DRAW_LINE);
      }
      else      
      {
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      }
      
      SetLevelValue(0,levelOb);
      SetLevelValue(1,0.50);
      SetLevelValue(2,levelOs);
      
        //
        //
        //
        //
        //
   
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);
      
        //
        //
        //
        //
        //
      
   IndicatorShortName(timeFrameToString(timeFrame)+"  T3 Impulse Channel("+DoubleToStr(Per,2)+","+ImpulseMaPeriod+")");
return(0);
}

int deinit()  {  return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   int lastZag;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { buf[0] = MathMin(limit+1,Bars-1); return(0); }
           
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {   
     if (ShowZigZag)
     for(lastZag = limit+1; lastZag < Bars; lastZag++) if (ZZLow[lastZag] != 0 || ZZHigh[lastZag] != 0) break;
     for(i=limit; i>=0; i--)   
     {
        double impO = 0; if(Open[i]  > Open[i+1])  impO = Open[i]    - Open[i+1];
        double impC = 0; if(Close[i] < Close[i+1]) impC = Close[i+1] - Close[i];
        double smtO = MathMax(iT3(impO,Per,T3Hot,T3Original,i,0),0);
        double smtC = MathMax(iT3(impC,Per,T3Hot,T3Original,i,1),0);
        if (smtO+smtC!=0)
              buf[i] = smtO/(smtO+smtC);
        else  buf[i] = 0;
              LB[i]  = buf[ArrayMinimum(buf,HighLowPeriod,i)];
              HB[i]  = buf[ArrayMaximum(buf,HighLowPeriod,i)];
                        
       //
       //
       //
       //
       //
      
       if (!ShowZigZag) continue;
      
         ZZLow[i]  = 0;
         ZZHigh[i] = 0;
      
         if (LB[i] < LB[i+1])
         {
           if (ZZ[lastZag] == LB[lastZag])
               ZZ[lastZag] =  0;
               ZZ[i]       =  LB[i];
               ZZLow[i]    =  LB[i];
                              lastZag = i;
                              continue;
         }   
         if (HB[i] > HB[i+1])
         {
           if (ZZ[lastZag] == HB[lastZag])
               ZZ[lastZag] =  0;
               ZZ[i]       =  HB[i];
               ZZHigh[i]   =  HB[i];
                              lastZag = i;
                              continue;
         }   
         if (ZZ[i] != 0)
         {
           ZZ[i] = 0;
           for (lastZag=i+1; lastZag<Bars; lastZag++)
           {
              if (ZZLow[lastZag]  != 0) { ZZ[lastZag] = ZZLow[lastZag];  break; }
              if (ZZHigh[lastZag] != 0) { ZZ[lastZag] = ZZHigh[lastZag]; break; }
           }
               
         }          
    }
    
    for(i=limit; i>=0; i--)  
    {
       impma[i] = iMAOnArray(buf,Bars,ImpulseMaPeriod,0,ImpulseMaMode,i);
       trend[i] = trend[i+1]; 
	       if (buf[i] > impma[i]) trend[i]= 1; 
	       if (buf[i] < impma[i]) trend[i]=-1;
	 }
    manageAlerts();
    return(0);
    }
  
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (ShowZigZag)
    for (lastZag=limit+1; lastZag<Bars; lastZag++) if (ZZLow[lastZag] != 0 || ZZHigh[lastZag] != 0) break;
    for(i=limit; i>=0; i--) 
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
          buf[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Hot,T3Original,ImpulseMaPeriod,ImpulseMaMode,HighLowPeriod,ShowChannel,ShowZigZag,0,y);
          impma[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Hot,T3Original,ImpulseMaPeriod,ImpulseMaMode,HighLowPeriod,ShowChannel,ShowZigZag,1,y);
          ZZ[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Hot,T3Original,ImpulseMaPeriod,ImpulseMaMode,HighLowPeriod,ShowChannel,ShowZigZag,2,y);
          HB[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Hot,T3Original,ImpulseMaPeriod,ImpulseMaMode,HighLowPeriod,ShowChannel,ShowZigZag,3,y);
          LB[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Hot,T3Original,ImpulseMaPeriod,ImpulseMaMode,HighLowPeriod,ShowChannel,ShowZigZag,4,y);
          ZZLow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Hot,T3Original,ImpulseMaPeriod,ImpulseMaMode,HighLowPeriod,ShowChannel,ShowZigZag,5,y);
          ZZHigh[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Hot,T3Original,ImpulseMaPeriod,ImpulseMaMode,HighLowPeriod,ShowChannel,ShowZigZag,6,y);
          trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per,T3Hot,T3Original,ImpulseMaPeriod,ImpulseMaMode,HighLowPeriod,ShowChannel,ShowZigZag,7,y);
          
          //
          //
          //
          //
          //
      
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
             for(int k = 1; k < n; k++)
             {
                buf[i+k]   = buf[i]   + (buf[i+n]   - buf[i])   * k/n;
                impma[i+k] = impma[i] + (impma[i+n] - impma[i]) * k/n;
                HB[i+k]    = HB[i]    + (HB[i+n]    - HB[i])    * k/n;
                LB[i+k]    = LB[i]    + (LB[i+n]    - LB[i])    * k/n;
             }  	            
   }  
   manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) !=Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" t3 impulse ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," t3 impulse "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}